#ifndef CC04SDK_H
#define CC04SDK_H

/***********************************************************************
 *
 * ļ
 *
************************************************************************/


unsigned short __stdcall CRC16(unsigned char *puchData, int usDataLen);

int __stdcall DllBind(unsigned int nSlaver);
int __stdcall IsComOpen(void);
int __stdcall OpenCom(DWORD dwPort);
void __stdcall CloseCom(void);
int __stdcall SetDefault(unsigned int nSlaver);

int __stdcall GetSerial(unsigned int nSlaver, char* szID);
int __stdcall GetWorkMode(unsigned int nSlaver, int* nWorkMode);
int __stdcall GetMotorVeer(unsigned int nSlaver, int* nMotorVeer);
int __stdcall GetRemoteFunction(unsigned int nSlaver, int* nFunction);
int __stdcall GetSwichState(unsigned int nSlaver, char* szSwichState);
int __stdcall GetIoInputState(unsigned int nSlaver, char* szInputState);
int __stdcall GetRightExtremity(unsigned int nSlaver, int* nLimit);
int __stdcall GetLeftExtremity(unsigned int nSlaver, int* nLimit);
int __stdcall GetRightLimit(unsigned int nSlaver, int* nLimit);
int __stdcall GetLeftLimit(unsigned int nSlaver, int* nLimit);
int __stdcall GetRunState(unsigned int nSlaver, int* nRunState);
int __stdcall GetRemoteKeyState(unsigned int nSlaver, int* nKeyState);
int __stdcall GetBiosDate(unsigned int nSlaver, char** szDate);
int __stdcall GetFactroyDate(unsigned int nSlaver, char** szDate);
int __stdcall GetBeginPoint(unsigned int nSlaver, float* fPoint);
int __stdcall GetEndPoint(unsigned int nSlaver, float* fPoint);
int __stdcall GetAutoBeginPoint(unsigned int nSlaver, float* fPoint);
int __stdcall GetAutoEndPoint(unsigned int nSlaver, float* fPoint);
int __stdcall GetResolution(unsigned int nSlaver, float* fReso);
int __stdcall GetDiameter(unsigned int nSlaver, float* fDia);
int __stdcall GetMotorSpeed(unsigned int nSlaver, float* fSpeed);
int __stdcall GetMotorAcc(unsigned int nSlaver, float* fAcc);
int __stdcall GetPulseCount(unsigned int nSlaver, float* fPulse);
int __stdcall GetDelayTime(unsigned int nSlaver, float* fTimes);
int __stdcall GetCurrentPoint(unsigned int nSlaver, float* fPoint);

int __stdcall SetMoveLeft(unsigned int nSlaver);
int __stdcall SetMoveRight(unsigned int nSlaver);
int __stdcall SetMoveAuto(unsigned int nSlaver);
int __stdcall SetMoveStop(unsigned int nSlaver);
int __stdcall SetSwichAllOff(unsigned int nSlaver);
int __stdcall SetSwichAllOn(unsigned int nSlaver);
int __stdcall SetSwichState(unsigned int nSlaver, unsigned int nSwich, unsigned int nState);
int __stdcall SetInit(unsigned int nSlaver);
int __stdcall SetFactroyDate(unsigned int nSlaver, char* szDate);
int __stdcall SetMotorSpeed(unsigned int nSlaver, float fSpeed);
int __stdcall SetMotorAcc(unsigned int nSlaver, float fAcc);
int __stdcall SetPulseCount(unsigned int nSlaver, float fPulse);
int __stdcall SetBeginPoint(unsigned int nSlaver, float fPoint);
int __stdcall SetEndPoint(unsigned int nSlaver, float fPoint);
int __stdcall SetAutoBeginPoint(unsigned int nSlaver, float fPoint);
int __stdcall SetAutoEndPoint(unsigned int nSlaver, float fPoint);
int __stdcall SetResolution(unsigned int nSlaver, float fReso);
int __stdcall SetDiameter(unsigned int nSlaver, float fDia);
int __stdcall ResetBeginPoint(unsigned int nSlaver);
int __stdcall SetWorkMode(unsigned int nSlaver, unsigned int nMode);
int __stdcall SetAddress(unsigned int nSlaver, unsigned int nNewAddr);
int __stdcall SetMotorVeer(unsigned int nSlaver, unsigned int nVeer);
int __stdcall SetRemoteFunction(unsigned int nSlaver, unsigned int nFunction);
int __stdcall SetDelayTime(unsigned int nSlaver, float fTimes);
int __stdcall FixedCurrentPoint(unsigned int nSlaver, const float* fNewPoint);

int __stdcall StrEncode(char* In, char* &Out, int iKey);
int __stdcall StrDecode(char* In, char* &Out, int iKey);

int __stdcall StringEncode(char *pstr, char* &pout, int *pkey);
int __stdcall StringDecode(char *pstr, char* &pout, int *pkey);

#endif